% dvehmoty.m ... program k prikladu na kmitani se dvema stupni volnosti

clear all
close all

global M0 om k1 k2 I1 I2

% Zadane hodnoty
I1=0.17
I2=0.38
k1=2.61e5
k2=1.68e5
M0=5
om=1300
                  
% pocatecni podminky
fi0=[0.001;
     0.003]
fi0dot=[0;
        0]
% Matice hmotnosti
M=[I1  0;
    0 I2];
% Matice tuhosti
K=[ k1   -k1;
   -k1 k1+k2];
% Amplituda budici sily
f0=[M0;
     0];

% nastaveni delky experimentu (s)
tstart=0;
tkonec=0.04;

% nastaveni maximalni velikosti kroku pri integraci
options=odeset('MaxStep',0.0001);

[t,z]=ode45(@zdot,[tstart:0.0001:tkonec],[fi0(1),fi0dot(1),fi0(2),fi0dot(2)],options);
 
% vykresleni
figure      % zalozi novy obrazek
plot(t,z(:,1),'b',t,z(:,3),'r')   % vykresleni prubehu
title('Celkove reseni pro zadane obecne pocatecni podminky')
xlabel('cas [s]'), ylabel('vychylka [rad]')
legend('fi1(t)','fi2(t)')

% vypocet amplitud vynucenych kmitu v zavislosti na menicim se omega
r=[];   % pripravim si prazdne pole, do ktereho budu ukladat r jako funkci omega
omega=0:2:1800;
for i=1:1:length(omega)
    r=[r, inv(K-omega(i)^2*M)*f0];
end
% vykresleni
figure
plot(omega, r(1,:),'b.',omega, r(2,:),'r.')
axis([0 omega(length(omega)) -1e-4 1e-4])   % upravuji si osy na obrazku, protoze pri rezonanci utikaji amplitudy k nekonecnu 
grid on
title('Amplitudove charakteristiky')
xlabel('omega [1/s]'), ylabel('vychylka [rad]')
legend('r1','r2')